package
{
	import away3d.containers.ObjectContainer3D;
	import away3d.containers.View3D;
	import away3d.debug.AwayStats;
	import away3d.entities.Mesh;
	import away3d.materials.TextureMaterial;
	import away3d.primitives.CubeGeometry;
	import away3d.textures.BitmapTexture;
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	
	[SWF(frameRate="60", width="960", height="540")]
	public class PrimitiveCubes extends Sprite
	{
		
		//----------------------------------------------------------
		//
		//   Static Property 
		//
		//----------------------------------------------------------
		
		private static const CELL_NUM:uint = 11;
		
		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------
		
		public function PrimitiveCubes()
		{
			if (stage)
				addedToStageHanlder();
			else
				addEventListener(Event.ADDED_TO_STAGE, addedToStageHanlder);
		}
		
		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------
		
		[Embed(source="/assets/image.png")]
		private var ImageCls:Class;
		
		private var container:ObjectContainer3D;
		private var cubes:Array = [];
		private var view:View3D;
		
		//----------------------------------------------------------
		//
		//   Function 
		//
		//----------------------------------------------------------
		
		private function addedToStageHanlder(event:Event = null):void
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			view = new View3D();
			view.antiAlias = 0;
			this.addChild(view);
			addChild(new AwayStats(view));
			
			container = new ObjectContainer3D();
			view.scene.addChild(container);
			view.camera.z = -700;
			
			var material:TextureMaterial = new TextureMaterial(new BitmapTexture(new ImageCls().bitmapData));
			var box:CubeGeometry = new CubeGeometry(30, 30, 30, 1, 1, 1, false);
			var mesh:Mesh = new Mesh(box, material);
			
			// Box
			for (var i:int = 0; i < CELL_NUM; i++)
			{
				for (var j:int = 0; j < CELL_NUM; j++)
				{
					for (var k:int = 0; k < CELL_NUM; k++)
					{
						var cube:Mesh = mesh.clone() as Mesh;
					
						cube.x = 50 * (i - CELL_NUM / 2);
						cube.y = 50 * (j - CELL_NUM / 2);
						cube.z = 50 * (k - CELL_NUM / 2);
						
						container.addChild(cube);
						this.cubes.push(cube);
					}
				}
			}
			
			this.addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		private function enterFrameHandler(ev:Event):void
		{
			container.rotationX += 1;
			container.rotationY += 1;
			
			view.render();
		}
	}
}